package cn.com.infosec.mobile.android.framework.crypto.impl.gm;

import java.math.BigInteger;

public class JPWNafMultiplier implements JPECMultiplier {
   public byte[] windowNaf(byte width, BigInteger k) {
      byte[] var7 = new byte[k.bitLength() + 1];
      short var3;
      BigInteger var4 = BigInteger.valueOf((long)(var3 = (short)(1 << width)));
      int var5 = 0;

      int var6;
      for(var6 = 0; k.signum() > 0; ++var5) {
         if (k.testBit(0)) {
            BigInteger var9;
            if ((var9 = k.mod(var4)).testBit(width - 1)) {
               var7[var5] = (byte)(var9.intValue() - var3);
            } else {
               var7[var5] = (byte)var9.intValue();
            }

            k = k.subtract(BigInteger.valueOf((long)var7[var5]));
            var6 = var5;
         } else {
            var7[var5] = 0;
         }

         k = k.shiftRight(1);
      }

      byte[] k1;
      byte[] var10000 = k1 = new byte[width = var6 + 1];
      System.arraycopy(var7, 0, k1, 0, width);
      return var10000;
   }

   public JPECPoint multiply(JPECPoint p, BigInteger k, JPPreCompInfo preCompInfo) {
      JPWNafPreCompInfo preCompInfo1;
      if (preCompInfo != null && preCompInfo instanceof JPWNafPreCompInfo) {
         preCompInfo1 = (JPWNafPreCompInfo)preCompInfo;
      } else {
         preCompInfo1 = new JPWNafPreCompInfo.<init>();
      }

      int var4;
      byte var5;
      byte var12;
      if ((var4 = k.bitLength()) < 13) {
         var12 = 2;
         var5 = 1;
      } else if (var4 < 41) {
         var12 = 3;
         var5 = 2;
      } else if (var4 < 121) {
         var12 = 4;
         var5 = 4;
      } else if (var4 < 337) {
         var12 = 5;
         var5 = 8;
      } else if (var4 < 897) {
         var12 = 6;
         var5 = 16;
      } else if (var4 < 2305) {
         var12 = 7;
         var5 = 32;
      } else {
         var12 = 8;
         var5 = 127;
      }

      int var6 = 1;
      JPECPoint[] var7;
      JPECPoint[] var10000 = var7 = preCompInfo1.getPreComp();
      JPECPoint var8 = preCompInfo1.getTwiceP();
      if (var10000 == null) {
         (var7 = new JPECPoint[1])[0] = p;
      } else {
         var6 = var7.length;
      }

      if (var8 == null) {
         var8 = p.twice();
      }

      if (var6 < var5) {
         var10000 = var7;
         var7 = new JPECPoint[var5];
         System.arraycopy(var10000, 0, var7, 0, var6);

         while(var6 < var5) {
            var7[var6] = var8.add(var7[var6 - 1]);
            ++var6;
         }
      }

      byte[] var9;
      int var13 = (var9 = this.windowNaf(var12, k)).length;
      JPECPoint k1 = p.getInfinity();

      for(var4 = var13 - 1; var4 >= 0; --var4) {
         k1 = k1.twice();
         if (var9[var4] != 0) {
            if (var9[var4] > 0) {
               k1 = k1.add(var7[(var9[var4] - 1) / 2]);
            } else {
               k1 = k1.subtract(var7[(-var9[var4] - 1) / 2]);
            }
         }
      }

      preCompInfo1.setPreComp(var7);
      preCompInfo1.setTwiceP(var8);
      p.setPreCompInfo(preCompInfo1);
      return k1;
   }
}
